package com.sf.kafka.util;

package ..deTemp.1744135777879;

import com.sf.kafka.util.AsyncCallBack;
import com.smartframework.web.core.utils.Constants;
import java.util.Properties;
import org.apache.kafka.clients.producer.Callback;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.apache.kafka.common.serialization.StringSerializer;
import org.apache.log4j.Logger;

public class ProducerClient {
  private static final Logger logger = Logger.getLogger(com.sf.kafka.util.ProducerClient.class);
  
  private KafkaProducer producer;
  
  final long maxMsgs = 2147483647L;
  
  private Long messageNo = Long.valueOf(0L);
  
  private String group;
  
  public ProducerClient(String group) {
    Properties producerProperties = new Properties();
    producerProperties.put("bootstrap.servers", Constants.getAppPrefixedPara("bootstrap.servers", "20.97.197.107:9092,20.49.197.108:9092,20.8.137.109:9092"));
    producerProperties.put("acks", "1");
    producerProperties.put("request.timeout.ms", Integer.valueOf(60000));
    producerProperties.put("retries", Integer.valueOf(3));
    producerProperties.put("max.request.size", Integer.valueOf(10485760));
    producerProperties.put("batch.size", getKafkaConfigValue("batch.size", Integer.valueOf(65536)));
    producerProperties.put("linger.ms", getKafkaConfigValue("linger.ms", Integer.valueOf(100)));
    producerProperties.put("buffer.memory", getKafkaConfigValue("buffer.memory", Integer.valueOf(33554432)));
    producerProperties.put("key.serializer", StringSerializer.class.getName());
    producerProperties.put("value.serializer", StringSerializer.class.getName());
    this.group = group;
    this.producer = new KafkaProducer<>(producerProperties);
  }
  
  public Integer getKafkaConfigValue(String key, Integer defaultValue) {
    return Integer.valueOf(Constants.getAppPrefixedPara(key, defaultValue.toString()));
  }
  
  public void send(String destTopic, String messageStr) {
    if (this.messageNo.compareTo(Long.valueOf(2147483647L)) > 0)
      this.messageNo = Long.valueOf(0L); 
    logger.debug(String.format("异步发送数据主题:%s,messageNo:%d", new Object[] { destTopic, this.messageNo }));
    Long long_1 = this.messageNo, long_2 = this.messageNo = Long.valueOf(this.messageNo.longValue() + 1L);
    this.producer.send(new ProducerRecord<>(destTopic, messageStr), (Callback)new AsyncCallBack(System.currentTimeMillis(), long_1.longValue(), destTopic, messageStr));
    logger.debug(String.format("发送 主题:%s success", new Object[] { destTopic }));
  }
  
  public void close() {
    if (this.producer != null)
      try {
        this.producer.close();
      } catch (Exception e) {
        logger.info("Close  producer exception", e);
      }  
  }
}
